
package MessageMethod;

sub new {
  my $type = shift;
  my $ref = shift; ref $ref eq 'CODE' or die;
  bless $ref, $type;
}

sub AUTOLOAD {
  my $me = shift;
  (my $method) = $AUTOLOAD =~ m/::(.*)$/;
  return undef if $method eq 'DESTROY';
  return wantarray ? ($me->($method, @_)) : scalar $me->($method, @_);
}

1;

package Target;

foreach my $i qw(x y bot destx desty set_x set_y set_x_y query_x_y set_bot query_bot query_dest) {
  my $name = $i;
  *{$name} = sub :lvalue { my $a = 0; $a };
}
sub weight (@)  :lvalue { my $no = 1; $no }

1;


package Treasure;
@ISA=qw(Target);

# private
sub x (@)      :lvalue { $_[0]->[0] }
sub y (@)      :lvalue { $_[0]->[1] }
sub bot (@)    :lvalue { $_[0]->[2] }
sub weight (@) :lvalue { $_[0]->[3] }
sub destx (@)  :lvalue { $_[0]->[4] }
sub desty (@)  :lvalue { $_[0]->[5] }
sub id (@)     :lvalue { $_[0]->[6] }

# accessors
sub new         { my $type = shift; bless [@_ || (0)x4], $type; }
sub set_x       { &bot = undef; &x = $_[1]; 1; }
sub set_y       { &bot = undef; &y = $_[1]; 1; }
sub set_x_y     { &bot = undef; &x = $_[1]; &y = $_[2]; 1; }
sub query_x_y   { &bot ? map { &bot->[$_] } 0..1 : (&x, &y) }
sub set_bot     { &x = undef; &y = undef; &bot = $_[1]; 1; }
sub query_bot   { &bot }
sub query_dest  { (&destx, &desty) }
sub get_dropoff { return Dropoff->new(&destx, &desty) }

1;


package Treasure::Chest;

sub new { bless $_[1] || [], $_[0]; }
sub get { my $t = $_[0]->[$_[1]] ||= new Treasure; $t->id() = $_[1]; return $t; }
sub by_bot { 
  my $me = $_[0];
  my $bot = $_[1];
  my @res;
  foreach my $i (@$me) {
    next unless $i;
    next if ref $i eq 'ARRAY'; # wtf?
    push @res, $i if $i->bot() and $i->bot() eq $bot;
  }
  return @res;
}
sub zero {
  my $me = $_[0];
  my $id = $_[1];
  $me->[$id]->[0] = undef;
  $me->[$id]->[1] = undef;
  $me->[$id]->[2] = undef;
  $me->[$id]->[4] = undef;
  $me->[$id]->[5] = undef;
}

1;


package Base;
@ISA=qw(Target);

sub new         { my $type = shift; bless [@_], $type; }
sub x (@)       :lvalue { $_[0]->[0] }
sub y (@)       :lvalue { $_[0]->[1] }
sub visited (@) :lvalue { $_[0]->[2] }
sub query_x_y   { (&x, &y) }

1;


package Base::Chest;

sub new { bless $_[1] || [], $_[0]; }
sub get { $_[0]->[$_[1]] ||= new Base; return $_[0]->[$_[1]] }
sub create { 
  my $me = shift; 
  die unless scalar @_ == 2; 
  my $base = Base->new(@_) or die; 
  push @{$me}, $base; 
  $base; 
}

1;


package Dropoff;
@ISA=qw(Target);

sub new         { my $type = shift; bless [@_], $type; }
sub x (@)       :lvalue { $_[0]->[0] }
sub y (@)       :lvalue { $_[0]->[1] }
sub query_dest  { (&x, &y) }

1;

